import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ProjectField, ProjectFieldParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询应用参数
 */
export async function pageProjectField(params: ProjectFieldParam) {
  const res = await request.get<ApiResult<PageResult<ProjectField>>>(
    MODULES_API_URL + '/project/project-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询应用参数列表
 */
export async function listProjectField(params?: ProjectFieldParam) {
  const res = await request.get<ApiResult<ProjectField[]>>(
    MODULES_API_URL + '/project/project-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加应用参数
 */
export async function addProjectField(data: ProjectField) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改应用参数
 */
export async function updateProjectField(data: ProjectField) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除应用参数
 */
export async function removeProjectField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除应用参数
 */
export async function removeBatchProjectField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/project/project-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询应用参数
 */
export async function getProjectField(id: number) {
  const res = await request.get<ApiResult<ProjectField>>(
    MODULES_API_URL + '/project/project-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
